﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class ChangingLetter : MonoBehaviour {
	
	public Text accesibilidad;
	Text letra_buena;
	private int n;
	public  static int m;
	private float t;
	private GameObject[] piruleta;
	private GameObject[] right;
	private GameObject[] wrong;
	public RawImage transcripcionLetra;
	public RawImage InitButtons;
	public AudioClip[] abcAudio;
	private GameObject sonido;
	public Texture[] texturas;
	public Texture[] pTexturas;
	public Color[] colorSet;
	private string[] abecedario = {"A", "B", "C", "D", 
								   "E", "F", "G", "H", 
								   "I", "J", "K", "L", 
								   "M", "N", "Ñ", "O", 
								   "P", "Q", "R", "S", 
								   "T", "U", "V", "W", 
								   "X", "Y", "Z" };
	

	void Awake(){
		
		//ARRAY PIRULETAS BUENAS
		right = GameObject.FindGameObjectsWithTag("right");

		//ARRAY PIRULETAS MALAS
		wrong = GameObject.FindGameObjectsWithTag("wrong");

		//TRANSCRIPCIÓN DE LA LETRA AL ALFABETO DACTILOLÓGICO APARECE APAGADO
		transcripcionLetra.CrossFadeAlpha (0, 0, false);
		InitButtons.CrossFadeAlpha (1, 0.1f, false);
	
	}


	void Update () {

	if (CountDown.EndCount && CountDown.endGame==false) {
			
		InitButtons.CrossFadeAlpha (0, 1.4f, false);
		t =(int) Time.time;

		//INTÉRVALO CAMBIO LETRA (15 seg.)
		if (t % 15 == 0) {
				
			//RANDOM PARA PIRULETAS BUENAS
			n = (int)Random.Range (0, 26);

			//SONIDO LETRAS
			GetComponent<AudioSource> ().clip = abcAudio [n];
			GetComponent<AudioSource> ().Play();
			GetComponent<AudioSource> ().loop = false;

			//CAMBIAR LETRA
			letra_buena = GetComponent<Text> ();
			letra_buena.text = abecedario [n];

			//CAMBIAR LETRA A IMAGEN EN PANEL DE CONTROL
			transcripcionLetra.texture = pTexturas[n];

			// CLOSED CAPTIONING
			AccesibilidadSonido ();


			//PIRULETAS BUENAS
			for(int i = 0; i < right.Length; i++){
				if (right [i] != null) {
					right [i].GetComponent<Renderer> ().material.mainTexture = texturas[n];
				}
			}

			//PIRULETAS MALAS
			for(int i = 0; i < wrong.Length; i++){
				if (wrong [i] != null) {
						
					//RANDOM PIRULETAS MALAS
					m = (int)Random.Range (0, 26);
					
					// EVITA QUE LA LETRA DE LAS PIRULETAS BUENAS COINCIDA EN ALGUNA PIRULETA
					while (m == n) {
						m = (int)Random.Range (0, 26);
					}
					wrong [i].GetComponent<Renderer> ().material.mainTexture = texturas [m];

				}
			}
		}
		//SI SE PULSA LA TECLA ESPACIO SE VISUALIZA LA LETRA EN ALFABETO DACTILOLÓGICO
			if (Input.GetKeyDown ("space")) {
				tiempo_transcripcionLetra ();

			}
		}
	}

	//CORRUTINAS TIEMPO DE ESPERA DE LA TRANSCRIPCION DE LA LETRA. DESPUÉS 2 SEGUNDOS DESAPARECE

	public void tiempo_transcripcionLetra(){
		StartCoroutine (EmpezarCuentaAtras());
	}

	public IEnumerator EmpezarCuentaAtras(){
		transcripcionLetra.CrossFadeAlpha (1, 0.1f, false);
		yield return new WaitForSeconds (2);
		transcripcionLetra.CrossFadeAlpha (0, 0, false);
	}



	//CLOSED CAPTIONING

	public void AccesibilidadSonido(){
		StartCoroutine (Init());
	}

	public IEnumerator Init(){
		accesibilidad.text = "[ SONIDO: " + abecedario[n]+" ]";
		yield return new WaitForSeconds (3);
		accesibilidad.text = "";

	}

}

