﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class Lollipops : MonoBehaviour {
	public Text Accesib;
	public GameObject soundGame;
	public GameObject soundEngineCar;
	public Text points;
	public Text piruletas_b;
	public Text piruletas_m;
	public Text shadowPoints;
	public Text shadowPiruletas_b;
	public Text shadowPiruletas_m;
	public Text gameOver; //texto para el fin de juego
	private int pb;
	private int pm;
	public Image masPuntos;
	public Image menosPuntos;
	public  int cuentaPuntos;
	public int cuentaPiruletas_b;
	public GameObject[] controlVidas;
	private  int contadorVidas;
	private AudioSource player;
	public  AudioClip[] soundLollipop;
	public GameObject CrossAlpha;
	public GameObject imgGameOver;
	static public string[] accesibilidad = {
		" ",
		"[ SONIDO BOTÓN ]",
		"[ SONIDO APLAUSO, BOCINA Y AMBIENTE PÚBLICO ]",
		"[ SONIDO ARRANQUE MOTOR ]",
		"[ SONIDO RUIDO MOTOR Y MÚSICA SIMPÁTICA DURANTE TODO EL JUEGO ]",
		"[ SONIDO PITIDO ]",
		"[ SONIDO GO ]",
		"[ SONIDO ERROR ]",
		"[ SONIDO CORRECTO ]",
		"[ SONIDO QUITA VIDAS ]",
		"[ MUSICA ALEGRE Y MÁS ACELERADA DE FIN JUEGO ]"
	};



	void Awake () {
		imgGameOver.SetActive(false);
		CrossAlpha.SetActive (false);
		cuentaPuntos = 500;// puntos iniciales
		cuentaPiruletas_b = 30;// nº total piruletas buenas en escenario
		masPuntos.CrossFadeAlpha (0, 0, false);
		menosPuntos.CrossFadeAlpha (0, 0, false);
		contadorVidas = 0;
		controlVidas[contadorVidas].SetActive (true);
		pb = 0;
		pm = 0;
		Accesib.text=accesibilidad[0];
		player = GameObject.FindGameObjectWithTag("FX").GetComponent<AudioSource> ();
	}


	void Update(){
		if (CountDown.EndCount && CountDown.endGame == false) {
			//SI EL TIEMPO LLEGA A 5 MIN. ACABA LA PARTIDA
			if (Timer.minutos == 5 && Timer.segundos == 00) {
				InitGameOver ();
			}

			// DETECTA SI LAS RUEDAS TOCAN SUELO
			if (DetecWheel.volcado) {
				InitGameOver ();
			}
		}
	}


	void OnTriggerEnter(Collider other){
		if (CountDown.EndCount && CountDown.endGame == false) {

			//PIRULETAS BUENAS

			if (other.tag == "piruleta_b" && gameObject != null) {
				cuentaPuntos += 100; // suma 100 puntos
				cuentaPiruletas_b -= 1; // resta 1 piruleta del contador piruletas buenas
				points.text = cuentaPuntos.ToString () + " Points"; // muestra los puntos por pantalla
				shadowPoints.text = cuentaPuntos.ToString () + " Points"; //sombra puntos por pantalla
				mostrarSumaPuntos (); // muestra por pantalla +100
				pb += 1;// añade 1 piruleta al contador de piruletas buenas
				piruletas_b.text = pb.ToString () + " Good"; //muestra por pantalla el contador de piruletas buenas
				shadowPiruletas_b.text = pb.ToString () + " Good"; //sombra 
				player.clip = soundLollipop [0]; //activa el sonido piruleta buena
				player.Play ();
				Destroy (other.gameObject);

			//PIRULETAS MALAS

			}  else if (other.tag == "piruleta_m" && gameObject != null) {
				cuentaPuntos -= 100;
				points.text = cuentaPuntos.ToString () + " Points";
				shadowPoints.text = cuentaPuntos.ToString () + " Points";
				mostrarRestaPuntos ();
				pm += 1;
				piruletas_m.text = pm.ToString () + " Bad";
				shadowPiruletas_m.text = pm.ToString () + " Bad";
				player.clip = soundLollipop [2];
				player.Play ();
				Destroy (other.gameObject);

			
			//PIRULETAS QUITAVIDAS

			} else if (other.tag == "quitavidas" && gameObject != null) {
				controlVidas [contadorVidas].SetActive (false);//apagar una vida del contador de vidas
				contadorVidas += 1;
				player.clip = soundLollipop [1];
				player.Play ();
				InitQuitaVidas ();
				Destroy (other.gameObject);
			}

			if (cuentaPiruletas_b <= 0 || cuentaPuntos <= 0 || contadorVidas >= 3) {
				InitGameOver ();
			}
		}
	}
	

	//CORRUTINAS PARA MOSTRAR +100 Y -100 DURANTE 1 SEGUNDO

	public void mostrarSumaPuntos(){
		StartCoroutine (EmpezarCuentaAtras1());
	}

	public IEnumerator EmpezarCuentaAtras1(){
		masPuntos.CrossFadeAlpha (1, 0.1f, false);
		Accesib.text=accesibilidad[8];
		yield return new WaitForSeconds (1);
		masPuntos.CrossFadeAlpha (0, 0, false);
		Accesib.text=accesibilidad[0];
	}

	public void mostrarRestaPuntos(){
		StartCoroutine (EmpezarCuentaAtras2());
	}

	public IEnumerator EmpezarCuentaAtras2(){
		menosPuntos.CrossFadeAlpha (1, 0.1f, false);
		Accesib.text=accesibilidad[7];
		yield return new WaitForSeconds (1);
		menosPuntos.CrossFadeAlpha (0, 0, false);
		Accesib.text=accesibilidad[0];
	}
		
	//CORRUTINA QUITAVIDAS

	public void InitQuitaVidas(){
		StartCoroutine (QuitaVidas());
	}

	public IEnumerator QuitaVidas(){
		Accesib.text=accesibilidad[9];
		yield return new WaitForSeconds (1);
		Accesib.text=accesibilidad[0];


	}

	//CORRUTINA PARA CONTROLAR EL GAME OVER

	public  void InitGameOver (){
		StartCoroutine (StartInitGameOver());
	}

	public  IEnumerator StartInitGameOver(){
		CountDown.endGame = true; //activar variable que controla el fin de juego
		CountDown.EndCount=false;
		CrossAlpha.SetActive (true); //activar transparencia de fin de juego
		imgGameOver.SetActive(true); // activar imagen game over

		// AVISO PERSONALIZADO DE GAME OVER
		if (contadorVidas >= 3) {
			gameOver.text = "Te quedaste sin vidas, inténtalo de nuevo";
		} else if (cuentaPuntos <= 0) {
			gameOver.text = "Te quedaste sin puntos, inténtalo de nuevo";
		} else if (cuentaPiruletas_b <= 0) {
			gameOver.text = "Enhorabuena, conseguiste todas las piruletas";
		} else if (DetecWheel.volcado) {
			gameOver.text = "Haz volcado el Cupcake, inténtalo de nuevo";
		} else if (Timer.minutos == 5 && Timer.segundos == 00) {
			gameOver.text = "Finalizó el tiempo, inténtalo de nuevo";
		}
		//APAGAR MÚSICA DE MOTOR Y DE JUEGO

		soundEngineCar.GetComponent<AudioSource> ().Stop ();
		soundGame.GetComponent<AudioSource> ().Stop ();

		//ACTIVAR MÚSICA FIN DE JUEGO
		yield return new WaitForSeconds (1);
		Accesib.text=accesibilidad[8];
		player.clip = soundLollipop[3]; 
		player.Play ();
		player.loop = true;
		Accesib.text=accesibilidad[10];

	}
}
